<template>
  <div class="full-width">
    <!-- country selection -->
    <div class="q-mt-lg">
      <div
        v-if="showCountrySelect"
        class="row full-width justify-center q-gutter-sm"
      >
        <q-btn
          v-for="country in countries"
          :key="country.name"
          style="max-width: 30%; background-color: rgba(255,255,255,0.1)!important;"
          text-color="white"
          color="white"
          :flat="!isCountrySelected(country)"
          :outline="isCountrySelected(country)"
          :disable="!country.enabled"
          size="md"
          :style="{
            opacity: !selectedCountry || isCountrySelected(country) ? 1 : 0.3
          }"
          @click="onClickCountry(country)"
        >
          <CountryOrRegionFlag
            :name="country.name"
            :image="country.image"
            :flag-height="flagHeight"
            :flat-visibility="flagVisibility"
          />
        </q-btn>
      </div>

      <div
        v-else-if="showCountry"
        class="q-pa-xs"
      >
        <CountryOrRegionFlag
          :name="selectedCountry.name"
          :image="selectedCountry.image"
          :flag-height="flagHeight"
          :flat-visibility="flagVisibility"
        />
      </div>
    </div>

    <!-- region selection -->
    <div class="q-mt-lg">
      <div
        v-if="showRegionSelect"
        class="row full-width justify-center q-gutter-x-sm"
      >
        <q-btn
          v-for="region in selectedCountry.regions"
          :key="region.region_id"
          :disable="!region.enabled"
          style="max-width: 30%; background-color: rgba(255,255,255,0.1)!important;"
          text-color="white"
          color="white"
          :flat="!isRegionSelected(region)"
          :outline="isRegionSelected(region)"
          size="md"
          :style="{
            opacity: !selectedRegion || isRegionSelected(region) ? 1 : 0.3
          }"
          @click="onClickRegion(region)"
        >
          <CountryOrRegionFlag
            :name="region.name"
            :image="region.image"
            :flag-height="flagHeight"
            :flat-visibility="flagVisibility"
          />
        </q-btn>
      </div>

      <div
        v-else-if="showRegion"
        class="q-pa-xs"
      >
        <CountryOrRegionFlag
          :name="selectedRegion.name"
          :image="selectedRegion.image"
          :flag-height="flagHeight"
          :flat-visibility="flagVisibility"
        />
      </div>
    </div>
  </div>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import { getRegionImageSrc } from 'src/utils/urls'
import CountryOrRegionFlag from 'src/pages/login/region-selection/components/CountryOrRegionFlag'

export default {
  name: 'CountriesAndRegionsSelection',
  components: {
    CountryOrRegionFlag
  },
  mixins: [
    PlatformMixin
  ],
  props: {
    countries: {
      type: Array,
      required: true
    },
    selectedCountry: {
      type: Object,
      default: null
    },
    selectedRegion: {
      type: Object,
      default: null
    }
  },
  emits: ['select-country', 'select-region'],
  data () {
    return {
      flagsPreloaded: false
    }
  },
  computed: {
    flagHeight () {
      return this.hasNoChoices ? '65px' : (this.isDesktopPlatform ? '55px' : '40px')
    },
    flagVisibility () {
      return this.flagsPreloaded ? 'visible' : 'hidden'
    },
    showCountrySelect () {
      return Boolean(this.countries?.length > 1 || !this.selectedCountry)
    },
    showCountry () {
      return Boolean(!this.showCountrySelect && this.selectedCountry && !this.selectedCountry?.regions?.length)
    },
    showRegionSelect () {
      return Boolean(this.selectedCountry && (this.selectedCountry?.regions?.length > 1 || !this.selectedRegion))
    },
    showRegion () {
      return Boolean(!this.showRegionSelect && this.selectedRegion)
    },
    hasNoChoices () {
      return this.countries?.length === 1 && !(this.selectedCountry?.regions?.length > 1)
    }
  },
  methods: {
    onClickCountry (country) {
      this.$emit('select-country', country)
    },
    onClickRegion (region) {
      this.$emit('select-region', region)
    },
    isCountrySelected (country) {
      return this.selectedCountry && this.selectedCountry.name === country.name
    },
    isRegionSelected (region) {
      return this.selectedRegion && this.selectedRegion.region_id === region.region_id
    },
    getRegionImageSrc (regionConfigImage) {
      return getRegionImageSrc(regionConfigImage)
    }
  },
  mounted () {
    // Preload country and regions flags
    const flagImages = []
    this.countries.forEach(country => {
      if (country.image) {
        flagImages.push(getRegionImageSrc(country.image))
      }
      (country.regions || []).forEach(region => {
        if (region.image) {
          flagImages.push(getRegionImageSrc(region.image))
        }
      })
    })
    Promise.all(flagImages.map(flagImage => new Promise(resolve => {
      const image = new Image()
      const onImageLoad = () => {
        image.removeEventListener('load', onImageLoad)
        resolve()
      }
      image.addEventListener('load', onImageLoad)
      image.src = flagImage
    }))).then(() => {
      // all images successfully preloaded
    }).finally(() => {
      // images loaded or failed
      this.flagsPreloaded = true
    })
  }
}
</script>
